#!/usr/bin/perl -w
####################################################################
###
###     script name : conver2MFCC.pl
### 	version: 1.0
###		modified by: Ken MacLean
###		mail: kmaclean@voxforge.org
###		Date: 2006.7.20
###     Command: ./convert2MFCC.pl FilesToConvert2MFCC.scp
###
### Copyright (C) 2006 Ken MacLean
###
### This program is free software; you can redistribute it and/or
### modify it under the terms of the GNU General Public License
### as published by the Free Software Foundation; either version 2
### of the License, or (at your option) any later version.
###
### This program is distributed in the hope that it will be useful,
### but WITHOUT ANY WARRANTY; without even the implied warranty of
### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
### GNU General Public License for more details.
###                                                                 
####################################################################

use strict;
use File::Spec;

my ($wav_file, $temp_file, $codetrain, @command, $line);
my ($wav_path, $wav_filename_nosuffix, $skip, $username, @wav_dirs, $wav_volume,$wav_directories,$wav_filename, @wav_filename);

# check usage
if (@ARGV != 1) {
  print "usage: $0 FilesToConvert2MFCC \n\n"; 
  exit (0);
}

# convert wav files to temporary MFC files
($codetrain) = @ARGV;
@command = ("HCopy", "-C", "../input_files/wav_config", "-S", $codetrain);
system(@command) == 0
   or die "system @command failed: $?"; 
   
# rename temp files to wav files using svn move - in order to conserve subversion history 
open (FILEIN,"$codetrain") || die ("Unable to open codetrain $codetrain file for reading");
while ($line = <FILEIN>) {
  chomp ($line);
  ($wav_file, $temp_file)=split(/ /, $line); # take a line, break words separated by spaces into an individual array element
  ($wav_volume,$wav_directories,$wav_filename) = File::Spec->splitpath( $wav_file );
  print "wav directory: $wav_directories \n";
  @wav_dirs = File::Spec->splitdir( $wav_directories );
   print "wav dirs: @wav_dirs \n";
  shift	@wav_dirs; shift @wav_dirs, shift @wav_dirs; 
  $wav_path = File::Spec->catdir( @wav_dirs );
  print "wav path: $wav_path \n";
  print "\$wav_filename: $wav_filename\n";
  @wav_filename = split(/\./,$wav_filename);
  print "\@wav_filename: @wav_filename\n";
  $wav_filename_nosuffix = shift(@wav_filename);
  print "\$wav_filename_nosuffix: $wav_filename_nosuffix \n";

# this operates on repository    
  @command = ("svn", "move", "-m", "\"test2 - trying to keep svn history when creating mfc files from wav files\"", 
  "-r", "HEAD", 
  "svn://10.8.0.1/VoxForge/Trunk/$wav_path/$wav_filename", 
  "svn://10.8.0.1/VoxForge/Trunk/$wav_path/$wav_filename_nosuffix.mfc", "--password", "test");
  system(@command) == 0
     or die "system @command failed: $?";     
       
# this operates on working copy, therefore need to update!       
# rename temp-filename.mfc to filename.mfc in working copy using O/S, this will NOT keep subversion history     
  @command = ("mv", $temp_file, $wav_file);
  system(@command) == 0
     or die "system @command failed: $?";     
# need to recomit changes - use eclipse svn client (subclipse)
}
close(FILEIN);


